import { isJSONObject } from '../../../helpers/json.js';
import { unmarshalMoney } from '../../../scw/custom-marshalling.js';
import { unmarshalArrayOfObject, unmarshalDate } from '../../../helpers/marshalling.js';

// This file was automatically generated. DO NOT EDIT.
// If you have any remark or suggestion do not hesitate to open an issue.
const unmarshalGetConsumptionResponseConsumption = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'GetConsumptionResponseConsumption' failed as data isn't a dictionary.`);
  }
  return {
    category: data.category,
    description: data.description,
    operationPath: data.operation_path,
    projectId: data.project_id,
    value: data.value ? unmarshalMoney(data.value) : undefined
  };
};
const unmarshalGetConsumptionResponse = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'GetConsumptionResponse' failed as data isn't a dictionary.`);
  }
  return {
    consumptions: unmarshalArrayOfObject(data.consumptions, unmarshalGetConsumptionResponseConsumption),
    updatedAt: unmarshalDate(data.updated_at)
  };
};
const unmarshalDiscountCoupon = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'DiscountCoupon' failed as data isn't a dictionary.`);
  }
  return {
    description: data.description
  };
};
const unmarshalDiscountFilter = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'DiscountFilter' failed as data isn't a dictionary.`);
  }
  return {
    type: data.type,
    value: data.value
  };
};
const unmarshalDiscount = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'Discount' failed as data isn't a dictionary.`);
  }
  return {
    coupon: data.coupon ? unmarshalDiscountCoupon(data.coupon) : undefined,
    creationDate: unmarshalDate(data.creation_date),
    description: data.description,
    filters: unmarshalArrayOfObject(data.filters, unmarshalDiscountFilter),
    id: data.id,
    mode: data.mode,
    organizationId: data.organization_id,
    startDate: unmarshalDate(data.start_date),
    stopDate: unmarshalDate(data.stop_date),
    value: data.value,
    valueRemaining: data.value_remaining,
    valueUsed: data.value_used
  };
};
const unmarshalListDiscountsResponse = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'ListDiscountsResponse' failed as data isn't a dictionary.`);
  }
  return {
    discounts: unmarshalArrayOfObject(data.discounts, unmarshalDiscount),
    totalCount: data.total_count
  };
};
const unmarshalInvoice = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'Invoice' failed as data isn't a dictionary.`);
  }
  return {
    dueDate: unmarshalDate(data.due_date),
    id: data.id,
    invoiceType: data.invoice_type,
    issuedDate: unmarshalDate(data.issued_date),
    number: data.number,
    startDate: unmarshalDate(data.start_date),
    totalTaxed: data.total_taxed ? unmarshalMoney(data.total_taxed) : undefined,
    totalUntaxed: data.total_untaxed ? unmarshalMoney(data.total_untaxed) : undefined
  };
};
const unmarshalListInvoicesResponse = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'ListInvoicesResponse' failed as data isn't a dictionary.`);
  }
  return {
    invoices: unmarshalArrayOfObject(data.invoices, unmarshalInvoice),
    totalCount: data.total_count
  };
};

export { unmarshalGetConsumptionResponse, unmarshalListDiscountsResponse, unmarshalListInvoicesResponse };
